<template>
  <market-top-categories v-if="route.path === '/market'" />
  <market-header v-if="isAuth" />
  <market-top-filters v-if="route.path === '/market'" />
  <router-view />
  <v-row v-if="route.path === '/market'">
    <v-col v-for="(product, index) in products" :key="index" cols="2">
      <market-card
        :id="product._id"
        :title="product.title"
        :price="product.price"
        :desc="product.description"
        :img="product?.image"
      />
    </v-col>
  </v-row>
</template>

<script setup>
import MarketCard from '@/components/market/MarketCard.vue'
import MarketHeader from '@/components/market/MarketHeader.vue'
import { onBeforeMount } from 'vue'
import { get, call } from 'vuex-pathify'
import { useRoute } from 'vue-router'
import MarketTopFilters from '@/components/market/MarketTopFilters.vue'
import MarketTopCategories from '@/components/market/MarketTopCategories.vue'

const route = useRoute()
onBeforeMount(() => checkProductsHandle())

function checkProductsHandle() {
  if (products.value.length <= 0) {
    getProducts()
  }
}

const isAuth = get('user/isAuth')
const getProducts = call('market/getProducts')
const products = get('market/filteredCards')
</script>
